#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTableWidget>
#include <QDebug>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QGridLayout>
#include <QtGui/QGroupBox>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QMainWindow>
#include <QtGui/QProgressBar>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>
#include <QtGui/QSpinBox>
#include <QtGui/QTableWidget>
#include <QtGui/QTreeWidget>
#include <QtGui/QWidget>
#include <QtGui/QTextEdit>
#include <cmath>
#include "cah.h"


class MainWindow:public QMainWindow {
      Q_OBJECT public:
	 MainWindow();

private slots:
	void openData();
	void makeCAH();

private:
	QString loadData();
	void resizePond(const uint size);
	bool saveResult(const QString & fileName);
	uint getDst();
	uint getPrec();
	uint getCri();
	bool testData(const QString & data);
	QVector<double> getPond();
	void makeTree(QList<Cluster> clusters);
	void addChilds(QTreeWidgetItem *root, QList<Cluster> cluters);
	void expandChilds(QTreeWidgetItem *root);

	QString dataFile;

	QWidget *centralwidget;
	QGridLayout *gridLayout;
	QGroupBox *poidBox;
	QGridLayout *gridLayout1;
	QTableWidget *poidWidget;
	QGroupBox *descrBox_2;
	QGridLayout *gridLayout2;
	QLabel *label_2;
	QSpinBox *spinBox_2;
	QGroupBox *descrBox;
	QGridLayout *gridLayout3;
	QLabel *label;
	QSpinBox *spinBox;
	QSpacerItem *spacerItem;
	QGroupBox *critereBox;
	QGridLayout *gridLayout4;
	QRadioButton *minButton;
	QRadioButton *maxButton;
	QRadioButton *moyButton;
	QGroupBox *disanceBox;
	QGridLayout *gridLayout5;
	QRadioButton *eucliButton;
	QRadioButton *eucli2Button;
	QGroupBox *dataBox;
	QGridLayout *gridLayout6;
	QPushButton *loadButton;
	QLineEdit *filenameEdit;
	QGroupBox *resultBox;
	QGridLayout *gridLayout7;
	QProgressBar *resultBar;
	QPushButton *calcButton;
	QTextEdit *textEdit;
	QTreeWidget *resultWidget;
};

#endif
