#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTableWidget>
#include <QDebug>

class QAction;
class QMenu;
class QTextEdit;

class MainWindow:public QMainWindow {
      Q_OBJECT public:
	 MainWindow();

protected:
	void closeEvent(QCloseEvent * event);

	private slots:void newFile();
	void open();
	bool save();
	bool saveAs();
	void about();
	void matrixWasModified();

public:
	void loadFile(const QString & fileName);

private:
	void setCurrentFile(const QString & fileName);
	void createActions();
	void createMenus();
	void readSettings();
	void writeSettings();
	bool maybeSave();
	bool fillTable(const QString & data);
	bool saveFile(const QString & fileName);
	QString exportTable();
	QString strippedName(const QString & fullFileName);
	void resizeTable(const uint width, const uint height);

	QTableWidget *matrix;
	QString curFile;

	QMenu *fileMenu;
	QMenu *helpMenu;
	QAction *newAct;
	QAction *openAct;
	QAction *saveAct;
	QAction *saveAsAct;
	QAction *exitAct;
	QAction *aboutAct;
	QAction *aboutQtAct;

	bool matrixIsModified;
};

#endif
